#
# tangent circle calculation
#

import math

def calc_tan_circle(radius, hy, x):
    #
    # center of ccircle : (0,0)
    # radius of ccircle : radius
    # distance between ccircle and hcl: hy
    # x-coordinate of mouse: x
    #
    # projection point on hcl: (x, hy)
    #
    # lots of algebra reduces to the following two cases
    #
    _cx = x
    if hy > 0.0:
        _num = pow(x, 2) - pow(hy, 2) - (2.0 * hy * radius) - pow(radius, 2)
        _den = (-2.0 * hy) - (2.0 * radius)
    else:
        _num = pow(x, 2) - pow(hy, 2) + (2.0 * hy * radius) - pow(radius, 2)
        _den = (2.0 * radius) - (2.0 * hy)
    print "num: %g" % _num
    print "den: %g" % _den
    _cy = _num/_den
    _radius = abs(_cy - hy)
    return _cx, _cy, _radius

#
# tangent line around two circles
#
# at most four lines
#

def _calc_values(ax, ay, bx, by, cx, cy):
    _den = pow((bx - ax), 2) + pow((by - ay), 2)
    _num = ((cx - ax) * (bx - ax)) + ((cy - ay) * (by - ay))
    _r = _num/_den
    print "r: %g" % _r
    _num = ((ay - cy) * (bx - ax)) - ((ax - cx) * (by - ay))
    _s = _num/_den
    # print "s: %g" % _s
    _sep = abs(_s) * math.sqrt(_den)
    print "sep: %g" % _sep

def _calc_tangent_triangle(r1, r2, sep, ip):
    _sine = r1/ip
    print "sin: %g" % _sine
    _angle = math.asin(_sine)
    print "angle: %g" % (_angle * (180.0/math.pi))
    _tan = math.tan(_angle)
    print "tan(angle): %g" % _tan
    _cosine = math.cos(_angle)
    print "cos(angle): %g" % _cosine
    _tanlen = r1/_tan
    print "tanlen: %g" % _tanlen
    _tx1 =  ip - (_tanlen * _cosine)
    print "tx1: %g" % _tx1
    _ty1 = _tanlen * _sine
    print "ty1: %g" % _ty1
    _dist = math.hypot(_tx1, _ty1)
    print "dist: %g" % _dist
    if abs(_dist - r1) > 1e-10:
        print "Bad tangent points for circle 1"
    _tanlen = r2/_tan
    print "tanlen: %g" % _tanlen
    if abs(ip) > abs(sep):
        _tx2 = ip - (_tanlen * _cosine)
        _ty2 = _tanlen * _sine
    else:
        _tx2 = ip + (_tanlen * _cosine)
        _ty2 = -1.0 * _tanlen * _sine
    print "tx2: %g" % _tx2        
    print "ty2: %g" % _ty2
    _dist = math.hypot((_tx2 - sep), _ty2)
    print "dist: %g" % _dist
    if abs(_dist - r2) > 1e-10:
        print "bad tangent points for circle 2"
    return _tx1, _ty1, _tx2, _ty2

def calc_two_circle_tangent(r1, r2, sep):
    _r1 = r1
    if not isinstance(_r1, float):
        _r1 = float(r1)
    if not _r1 > 0.0:
        raise ValueError, "Invalid radius: %g" % _r1
    _r2 = r2
    if not isinstance(_r2, float):
        _r2 = float(r2)
    if not _r2 > 0.0:
        raise ValueError, "Invalid radius: %g" % _r2
    _sep = sep
    if not isinstance(_sep, float):
        _sep = float(sep)
    if not (abs(_sep) + min(_r1, _r2)) > max(_r1, _r2): # small circle within larger
        return None
    _tangents = []
    if abs(_r1 - _r2) < 1e-10:
        print "same radii ..."
        _tangents.append((0.0, _r1, _sep, _r2))
        _tangents.append((0.0, -_r1, _sep, -_r2))
        if abs(_sep) > _r1 + _r2:
            _mid = _sep/2.0
            _angle = math.asin(_r1/_mid)
            _tanlen = _r1/math.tan(_angle)
            _xt = _tanlen * math.cos(_angle)
            _yt = _tanlen * math.sin(_angle)
            _tx1 = _mid - _xt
            _ty1 = _yt
            _tx2 = _mid + _xt
            _ty2 = -_yt
            _tangents.append((_tx1, _ty1, _tx2, _ty2))
            _calc_values(_tx1, _ty1, _tx2, _ty2, 0.0, 0.0)
            _calc_values(_tx1, _ty1, _tx2, _ty2, _sep, 0.0)
            _tangents.append((_tx1, -_ty1, _tx2, -_ty2))
            _calc_values(_tx1, -_ty1, _tx2, -_ty2, 0.0, 0.0)
            _calc_values(_tx1, -_ty1, _tx2, -_ty2, _sep, 0.0)
    else:
        _alpha = pow((_r1/_r2), 2)
        print "alpha: %g" % _alpha
        _a = (1.0 - _alpha)
        print "a: %g" % _a
        _b = (2.0 * _alpha * _sep)
        print "b: %g" % _b
        _c = (-1.0 * _alpha * pow(_sep, 2))
        print "c: %g" % _c
        _det = pow(_b, 2) - (4.0 * _a * _c)
        print "det: %g" % _det
        if _det > 0.0: # can this ever be negative?
            _denom = 2.0 * _a
            _det_sqrt = math.sqrt(_det)
            _num = (-1.0 * _b) + _det_sqrt
            _offset = _num/_denom
            print ": %g" % _offset
            if abs(_offset) > _r1 and abs(_offset - _sep) > _r2:
                _tpts = _calc_tangent_triangle(_r1, _r2, _sep, _offset)
                _tangents.append(_tpts)
                _tx1, _ty1, _tx2, _ty2 = _tpts 
                _calc_values(_tx1, _ty1, _tx2, _ty2, 0.0, 0.0)
                _calc_values(_tx1, _ty1, _tx2, _ty2, _sep, 0.0)
                _calc_values(_tx2, _ty2, _tx1, _ty1, _sep, 0.0)
                _calc_values(_tx2, _ty2, _tx1, _ty1, 0.0, 0.0)
                _tpts = (_tx1, - _ty1, _tx2, -_ty2)
                _tangents.append(_tpts)
                _calc_values(_tx1, -_ty1, _tx2,-_ty2, 0.0, 0.0)
                _calc_values(_tx1, -_ty1, _tx2, -_ty2, _sep, 0.0)
                _calc_values(_tx2, -_ty2, _tx1, -_ty1, _sep, 0.0)
                _calc_values(_tx2, -_ty2, _tx1, -_ty1, 0.0, 0.0)
            _num = (-1.0 * _b) - _det_sqrt
            _offset = _num/_denom
            if abs(_offset) > _r1 and abs(_offset - _sep) > _r2:
                _tpts = _calc_tangent_triangle(_r1, _r2, _sep, _offset) 
                _tangents.append(_tpts)
                _tx1, _ty1, _tx2, _ty2 = _tpts
                _calc_values(_tx1, _ty1, _tx2, _ty2, 0.0, 0.0)
                _calc_values(_tx1, _ty1, _tx2, _ty2, _sep, 0.0)
                _calc_values(_tx2, _ty2, _tx1, _ty1, _sep, 0.0)
                _calc_values(_tx2, _ty2, _tx1, _ty1, 0.0, 0.0)
                _tpts = (_tx1, - _ty1, _tx2, -_ty2)
                _tangents.append(_tpts)
                _calc_values(_tx1, -_ty1, _tx2,-_ty2, 0.0, 0.0)
                _calc_values(_tx1, -_ty1, _tx2, -_ty2, _sep, 0.0)
                _calc_values(_tx2, -_ty2, _tx1, -_ty1, _sep, 0.0)
                _calc_values(_tx2, -_ty2, _tx1, -_ty1, 0.0, 0.0)
    return _tangents
